Index: /pjproject/trunk/aconfigure.ac
===================================================================
--- /pjproject/trunk/aconfigure.ac	(revision 2600)
+++ /pjproject/trunk/aconfigure.ac	(revision 2601)
@@ -534,4 +534,16 @@
 	      AC_MSG_RESULT([Checking if G.722 codec is disabled...no]))
 
+dnl # Include G722.1 codec
+AC_SUBST(ac_no_g7221_codec)
+AC_ARG_ENABLE(g7221-codec,
+	      AC_HELP_STRING([--disable-g7221-codec],
+			     [Exclude G.7221 codec in the build]),
+	      [if test "$enable_g7221_codec" = "no"; then
+		[ac_no_g7221_codec=1]
+		AC_DEFINE(PJMEDIA_HAS_G7221_CODEC,0)
+		AC_MSG_RESULT([Checking if G.722.1 codec is disabled...yes])
+	       fi],
+	      AC_MSG_RESULT([Checking if G.722.1 codec is disabled...no]))
+
 dnl # Include Speex codec
 AC_SUBST(ac_no_speex_codec)
Index: /pjproject/trunk/build.mak.in
===================================================================
--- /pjproject/trunk/build.mak.in	(revision 2600)
+++ /pjproject/trunk/build.mak.in	(revision 2601)
@@ -27,4 +27,9 @@
 APP_THIRD_PARTY_LIBS += -lilbccodec-$(TARGET_NAME)
 APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libilbccodec-$(LIB_SUFFIX)
+endif
+
+ifneq (@ac_no_g7221_codec@,1)
+APP_THIRD_PARTY_LIBS += -lg7221codec-$(TARGET_NAME)
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libg7221codec-$(LIB_SUFFIX)
 endif
 
Index: /pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- /pjproject/trunk/pjmedia/build/Makefile	(revision 2600)
+++ /pjproject/trunk/pjmedia/build/Makefile	(revision 2601)
@@ -97,5 +97,5 @@
 			ipp_codecs.o $(CODEC_OBJS)
 export PJMEDIA_CODEC_CFLAGS += $(_CFLAGS) $(GSM_CFLAGS) $(SPEEX_CFLAGS) \
-			$(ILBC_CFLAGS) $(IPP_CFLAGS)
+			$(ILBC_CFLAGS) $(IPP_CFLAGS) $(G7221_CFLAGS)
 
 
Index: /pjproject/trunk/pjmedia/build/os-auto.mak.in
===================================================================
--- /pjproject/trunk/pjmedia/build/os-auto.mak.in	(revision 2600)
+++ /pjproject/trunk/pjmedia/build/os-auto.mak.in	(revision 2601)
@@ -29,4 +29,5 @@
 AC_NO_ILBC_CODEC=@ac_no_ilbc_codec@
 AC_NO_G722_CODEC=@ac_no_g722_codec@
+AC_NO_G7221_CODEC=@ac_no_g7221_codec@
 
 export CODEC_OBJS=
@@ -74,4 +75,11 @@
 endif
 
+ifeq ($(AC_NO_G7221_CODEC),1)
+export CFLAGS += -DPJMEDIA_HAS_G7221_CODEC=0
+else
+export CODEC_OBJS += g7221.o
+export G7221_CFLAGS += -I$(THIRD_PARTY)
+endif
+
 
 #
Index: /pjproject/trunk/pjmedia/build/os-darwinos.mak
===================================================================
--- /pjproject/trunk/pjmedia/build/os-darwinos.mak	(revision 2600)
+++ /pjproject/trunk/pjmedia/build/os-darwinos.mak	(revision 2601)
@@ -25,4 +25,5 @@
 AC_NO_ILBC_CODEC=0
 AC_NO_G722_CODEC=0
+AC_NO_G7221_CODEC=0
 
 export CODEC_OBJS=
@@ -71,4 +72,11 @@
 endif
 
+ifeq ($(AC_NO_G7221_CODEC),1)
+export CFLAGS += -DPJMEDIA_HAS_G7221_CODEC=0
+else
+export CODEC_OBJS += g7221.o
+export G7221_CFLAGS += -I$(THIRD_PARTY)
+endif
+
 
 #
Index: /pjproject/trunk/pjmedia/build/os-linux.mak
===================================================================
--- /pjproject/trunk/pjmedia/build/os-linux.mak	(revision 2600)
+++ /pjproject/trunk/pjmedia/build/os-linux.mak	(revision 2601)
@@ -20,4 +20,5 @@
 AC_NO_ILBC_CODEC=0
 AC_NO_G722_CODEC=0
+AC_NO_G7221_CODEC=0
 
 export CODEC_OBJS=
@@ -65,4 +66,11 @@
 endif
 
+ifeq ($(AC_NO_G7221_CODEC),1)
+export CFLAGS += -DPJMEDIA_HAS_G7221_CODEC=0
+else
+export CODEC_OBJS += g7221.o
+export G7221_CFLAGS += -I$(THIRD_PARTY)
+endif
+
 
 #
Index: /pjproject/trunk/pjmedia/build/os-win32.mak
===================================================================
--- /pjproject/trunk/pjmedia/build/os-win32.mak	(revision 2600)
+++ /pjproject/trunk/pjmedia/build/os-win32.mak	(revision 2601)
@@ -21,4 +21,5 @@
 AC_NO_ILBC_CODEC=0
 AC_NO_G722_CODEC=0
+AC_NO_G7221_CODEC=0
 
 export CODEC_OBJS=
@@ -67,4 +68,11 @@
 endif
 
+ifeq ($(AC_NO_G7221_CODEC),1)
+export CFLAGS += -DPJMEDIA_HAS_G7221_CODEC=0
+else
+export CODEC_OBJS += g7221.o
+export G7221_CFLAGS += -I$(THIRD_PARTY)
+endif
+
 
 #
Index: /pjproject/trunk/pjmedia/include/pjmedia-codec/config_auto.h.in
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia-codec/config_auto.h.in	(revision 2600)
+++ /pjproject/trunk/pjmedia/include/pjmedia-codec/config_auto.h.in	(revision 2601)
@@ -61,4 +61,9 @@
 #endif
 
+/* G7221 codec */
+#ifndef PJMEDIA_HAS_G7221_CODEC
+#undef PJMEDIA_HAS_G7221_CODEC
+#endif
+
 
 #endif	/* __PJMEDIA_CODEC_CONFIG_AUTO_H_ */
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/g7221.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/g7221.c	(revision 2600)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/g7221.c	(revision 2601)
@@ -36,5 +36,5 @@
 #if defined(PJMEDIA_HAS_G7221_CODEC) && PJMEDIA_HAS_G7221_CODEC!=0
 
-#include "../../third_party/g7221/common/defs.h"
+#include "../../../third_party/g7221/common/defs.h"
 
 #define THIS_FILE	    "g7221.c"
Index: /pjproject/trunk/pjsip-apps/build/Samples-vc.mak
===================================================================
--- /pjproject/trunk/pjsip-apps/build/Samples-vc.mak	(revision 2600)
+++ /pjproject/trunk/pjsip-apps/build/Samples-vc.mak	(revision 2601)
@@ -33,7 +33,8 @@
 SPEEX_LIB = ..\..\third_party\lib\libspeex-$(TARGET)$(LIBEXT)
 SRTP_LIB = ..\..\third_party\lib\libsrtp-$(TARGET)$(LIBEXT)
+G7221_LIB = ..\..\third_party\lib\libg7221codec-$(TARGET)$(LIBEXT)
 
 THIRD_PARTY_LIBS = $(GSM_LIB) $(ILBC_LIB) $(PORTAUDIO_LIB) $(RESAMPLE_LIB) \
-				   $(SPEEX_LIB) $(SRTP_LIB)
+				   $(SPEEX_LIB) $(SRTP_LIB) $(G7221_LIB)
 
 LIBS = $(PJSUA_LIB_LIB) $(PJSIP_UA_LIB) $(PJSIP_SIMPLE_LIB) \
Index: /pjproject/trunk/third_party/build/g7221/Makefile
===================================================================
--- /pjproject/trunk/third_party/build/g7221/Makefile	(revision 2601)
+++ /pjproject/trunk/third_party/build/g7221/Makefile	(revision 2601)
@@ -0,0 +1,63 @@
+include ../../../build.mak
+include ../../../build/common.mak
+
+export LIBDIR := ../../lib
+
+RULES_MAK := $(PJDIR)/build/rules.mak
+
+export G7221_CODEC_LIB := ../../lib/libg7221codec-$(TARGET_NAME)$(LIBEXT)
+
+###############################################################################
+# Gather all flags.
+#
+export _CFLAGS 	:= $(CC_CFLAGS) $(OS_CFLAGS) $(HOST_CFLAGS) $(M_CFLAGS) \
+		   $(CFLAGS) $(CC_INC)../.. $(CC_INC)../../g7221/common \
+		   $(CC_INC)../../g7221/common/stl-files \
+		   $(CC_INC)../../../pjlib/include
+export _CXXFLAGS:= $(_CFLAGS) $(CC_CXXFLAGS) $(OS_CXXFLAGS) $(M_CXXFLAGS) \
+		   $(HOST_CXXFLAGS) $(CXXFLAGS)
+export _LDFLAGS := $(CC_LDFLAGS) $(OS_LDFLAGS) $(M_LDFLAGS) $(HOST_LDFLAGS) \
+		   $(LDFLAGS) 
+
+export G7221_CODEC_SRCDIR = ../../g7221
+export G7221_CODEC_OBJS = common/common.o common/huff_tab.o common/tables.o \
+                	common/stl-files/basop32.o common/stl-files/count.o \
+                	decode/coef2sam.o decode/dct4_s.o decode/decoder.o \
+                	encode/dct4_a.o encode/sam2coef.o encode/encoder.o
+
+export G7221_CODEC_CFLAGS = $(_CFLAGS)
+
+
+export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 
+###############################################################################
+# Main entry
+#
+# $(TARGET) is defined in os-$(OS_NAME).mak file in current directory.
+#
+TARGETS := libg7221codec
+
+all: $(TARGETS)
+
+doc:
+	cd .. && doxygen docs/doxygen.cfg
+
+dep: depend
+distclean: realclean
+
+.PHONY: dep depend libg7221codec clean realclean distclean
+
+libg7221codec:
+	$(MAKE) -f $(RULES_MAK) APP=G7221_CODEC app=libg7221codec $(G7221_CODEC_LIB)
+
+clean print_lib:
+	$(MAKE) -f $(RULES_MAK) APP=G7221_CODEC app=libg7221codec $@
+
+realclean:
+	$(subst @@,$(subst /,$(HOST_PSEP),.ilbc-$(TARGET_NAME).depend),$(HOST_RMR))
+	
+	$(MAKE) -f $(RULES_MAK) APP=G7221_CODEC app=libg7221codec $@
+
+depend:
+	$(MAKE) -f $(RULES_MAK) APP=G7221_CODEC app=libg7221codec $@
+
+
Index: /pjproject/trunk/third_party/build/os-auto.mak.in
===================================================================
--- /pjproject/trunk/third_party/build/os-auto.mak.in	(revision 2600)
+++ /pjproject/trunk/third_party/build/os-auto.mak.in	(revision 2601)
@@ -12,5 +12,10 @@
 endif
 
+ifneq (@ac_no_g7221_codec@,1)
+DIRS += g7221
+endif
+
 ifneq ($(findstring pa,@ac_pjmedia_snd@),)
 DIRS += portaudio
 endif
+
Index: /pjproject/trunk/third_party/build/os-darwinos.mak
===================================================================
--- /pjproject/trunk/third_party/build/os-darwinos.mak	(revision 2600)
+++ /pjproject/trunk/third_party/build/os-darwinos.mak	(revision 2601)
@@ -3,4 +3,5 @@
 DIRS += speex
 DIRS += portaudio
+DIRS += g7221
 
 
Index: /pjproject/trunk/third_party/build/os-linux.mak
===================================================================
--- /pjproject/trunk/third_party/build/os-linux.mak	(revision 2600)
+++ /pjproject/trunk/third_party/build/os-linux.mak	(revision 2601)
@@ -3,4 +3,5 @@
 DIRS += speex
 DIRS += portaudio
+DIRS += g7221
 
 
Index: /pjproject/trunk/third_party/build/os-win32.mak
===================================================================
--- /pjproject/trunk/third_party/build/os-win32.mak	(revision 2600)
+++ /pjproject/trunk/third_party/build/os-win32.mak	(revision 2601)
@@ -3,4 +3,5 @@
 DIRS += speex
 DIRS += portaudio
+DIRS += g7221
 
 
Index: /pjproject/trunk/third_party/g7221/common/stl-files/basop32.c
===================================================================
--- /pjproject/trunk/third_party/g7221/common/stl-files/basop32.c	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/common/stl-files/basop32.c	(revision 2601)
@@ -712,5 +712,5 @@
  |___________________________________________________________________________|
 */
-Word16 round (Word32 L_var1)
+Word16 itu_round (Word32 L_var1)
 {
     Word16 var_out;
Index: /pjproject/trunk/third_party/g7221/common/stl-files/basop32.h
===================================================================
--- /pjproject/trunk/third_party/g7221/common/stl-files/basop32.h	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/common/stl-files/basop32.h	(revision 2601)
@@ -55,5 +55,5 @@
 Word16 extract_h (Word32 L_var1);         /* Extract high,        1   */
 Word16 extract_l (Word32 L_var1);         /* Extract low,         1   */
-Word16 round (Word32 L_var1);             /* Round,               1   */
+Word16 itu_round (Word32 L_var1);         /* Round,               1   */
 Word32 L_mac (Word32 L_var3, Word16 var1, Word16 var2);   /* Mac,  1  */
 Word32 L_msu (Word32 L_var3, Word16 var1, Word16 var2);   /* Msu,  1  */
Index: /pjproject/trunk/third_party/g7221/common/stl-files/typedef.h
===================================================================
--- /pjproject/trunk/third_party/g7221/common/stl-files/typedef.h	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/common/stl-files/typedef.h	(revision 2601)
@@ -16,4 +16,20 @@
 #ifndef TYPEDEF_H
 #define TYPEDEF_H "$Id $"
+
+#if 1
+
+/* Use PJLIB types definitions (for PJLIB sync'd platforms compatibility? 
+ * e.g: mingw32 was not supported by the original version).
+ */
+#include <pj/types.h>
+
+typedef pj_int8_t Word8;
+typedef pj_int16_t Word16;
+typedef pj_int32_t Word32;
+typedef pj_uint16_t UWord16;
+typedef pj_uint32_t UWord32;
+typedef int Flag;
+
+#else
 
 #include <limits.h>
@@ -53,3 +69,6 @@
 #endif
 
+#endif /* if 0 */
+
 #endif /* TYPEDEF_H */
+
Index: /pjproject/trunk/third_party/g7221/decode/coef2sam.c
===================================================================
--- /pjproject/trunk/third_party/g7221/decode/coef2sam.c	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/decode/coef2sam.c	(revision 2601)
@@ -148,5 +148,5 @@
         sum = L_mac(sum,*win_new++, *--new_ptr);
         sum = L_mac(sum,*--win_old, *old_ptr++);
-        *out_ptr++ = round(L_shl(sum,2));
+        *out_ptr++ = itu_round(L_shl(sum,2));
         move16();
 
@@ -161,5 +161,5 @@
         sum = L_mac(sum,*win_new++, *new_ptr++);
         sum = L_mac(sum,negate(*--win_old), *--old_ptr);
-        *out_ptr++ = round(L_shl(sum,2));
+        *out_ptr++ = itu_round(L_shl(sum,2));
         move16();
     }
Index: /pjproject/trunk/third_party/g7221/decode/dct4_s.c
===================================================================
--- /pjproject/trunk/third_party/g7221/decode/dct4_s.c	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/decode/dct4_s.c	(revision 2601)
@@ -292,5 +292,5 @@
                 sum = L_mac(sum, pair_ptr[i],dct_core_s[i][k]);
             }
-            buffer_swap[k] = round(sum);
+            buffer_swap[k] = itu_round(sum);
         }
         
@@ -402,5 +402,5 @@
                 sum = L_mac(sum,cos_even,in_low_even);
                 sum = L_mac(sum,negate(msin_even),in_high_even);
-                out_low_even = round(L_shl(sum,1));
+                out_low_even = itu_round(L_shl(sum,1));
                 
                 sum = 0L;
@@ -408,5 +408,5 @@
                 sum = L_mac(sum,msin_even,in_low_even);
                 sum = L_mac(sum,cos_even,in_high_even);
-                out_high_even = round(L_shl(sum,1));
+                out_high_even = itu_round(L_shl(sum,1));
                 
                 sum = 0L;
@@ -414,5 +414,5 @@
                 sum = L_mac(sum,cos_odd,in_low_odd);
                 sum = L_mac(sum,msin_odd,in_high_odd);
-                out_low_odd = round(L_shl(sum,1));
+                out_low_odd = itu_round(L_shl(sum,1));
                 
                 sum = 0L;
@@ -420,5 +420,5 @@
                 sum = L_mac(sum,msin_odd,in_low_odd);
                 sum = L_mac(sum,negate(cos_odd),in_high_odd);
-                out_high_odd = round(L_shl(sum,1));
+                out_high_odd = itu_round(L_shl(sum,1));
                 
                 *out_ptr_low++  = out_low_even;
Index: /pjproject/trunk/third_party/g7221/encode/dct4_a.c
===================================================================
--- /pjproject/trunk/third_party/g7221/encode/dct4_a.c	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/encode/dct4_a.c	(revision 2601)
@@ -226,5 +226,5 @@
                 sum = L_mac(sum, pair_ptr[i],dct_core_a[i][k]);
             }
-            buffer_swap[k] = round(sum);
+            buffer_swap[k] = itu_round(sum);
         }
         /* address arithmetic */
@@ -313,15 +313,15 @@
                 neg_msin_even = negate(msin_even);
                 sum=L_mac(sum,neg_msin_even,in_high_even);
-                out_low_even = round(sum);
+                out_low_even = itu_round(sum);
 
                 sum = 0L;
                 sum=L_mac(sum,msin_even,in_low_even);
                 sum=L_mac(sum,cos_even,in_high_even);
-                out_high_even= round(sum);
+                out_high_even= itu_round(sum);
 
                 sum = 0L;
                 sum=L_mac(sum,cos_odd,in_low_odd);
                 sum=L_mac(sum,msin_odd,in_high_odd);
-                out_low_odd= round(sum);
+                out_low_odd= itu_round(sum);
 
                 sum = 0L;
@@ -329,5 +329,5 @@
                 neg_cos_odd = negate(cos_odd);
                 sum=L_mac(sum,neg_cos_odd,in_high_odd);
-                out_high_odd= round(sum);
+                out_high_odd= itu_round(sum);
 
                 *out_ptr_low++  = out_low_even;
Index: /pjproject/trunk/third_party/g7221/encode/sam2coef.c
===================================================================
--- /pjproject/trunk/third_party/g7221/encode/sam2coef.c	(revision 2600)
+++ /pjproject/trunk/third_party/g7221/encode/sam2coef.c	(revision 2601)
@@ -121,5 +121,5 @@
         acca = L_mac(acca,*--win_low, *--sam_low);
         acca = L_mac(acca,*win_high++, *sam_high++);
-        temp = round(acca); 
+        temp = itu_round(acca); 
         
         *dst_ptr++ = temp;
@@ -146,5 +146,5 @@
         samp_high = *--sam_high;
         acca = L_mac(acca, neg_win_low, samp_high);
-        temp = round(acca); 
+        temp = itu_round(acca); 
         
         *dst_ptr++=temp;
